Option Explicit
'
Const OUTPUTDIR = "c:\MERebuild\" ' output folder with trailing slash
Const SQLDBIP = "213.x.x.x"
Const SQLDBDB = "HelmDb"
Const SQLDBUser = "helmdbuser"
Const SQLDBPass = "xxx"
'


Public Sub AddressMap()

    Dim cnDB As New ADODB.Connection
    Dim rst As New ADODB.Recordset
    Dim rstDomains As ADODB.Recordset
    Dim rstAliases As ADODB.Recordset
    
    Dim objFSO As New FileSystemObject
    Dim objFile As TextStream
    
    Dim strSQL As String
    Dim strPOP3 As String
    Dim strPostOffice As String
    Dim strCatch As String
    Dim strPOPSplit() As String
    Dim strDomain As String
    
    Dim lngDomainID As Long
    Dim i As Long
    
    cnDB.Open "Provider=sqloledb;" & _
                    "Data Source=" & SQLDBIP & ";" & _
                    "Initial Catalog=" & SQLDBDB & ";" & _
                    "User Id=" & SQLDBUser & ";" & _
                    "Password=" & SQLDBPass & ";"
    
    strSQL = "SELECT HostDomain.DomainName, HostDomain.DomainId,
HostDomain.DomainAliasId " & _
            "FROM POP3Account INNER JOIN HostDomain ON POP3Account.DomainId
= HostDomain.DomainId " & _
            "GROUP BY HostDomain.DomainName, HostDomain.DomainName,
HostDomain.DomainId, HostDomain.DomainAliasId " & _
            "HAVING HostDomain.DomainAliasId=0;"
        
    rst.Open strSQL, cnDB
    
    If Not objFSO.FolderExists(OUTPUTDIR & "config") Then
        objFSO.CreateFolder (OUTPUTDIR & "config")
    End If
    Set objFile = objFSO.CreateTextFile(OUTPUTDIR &
"config\address-map.tab", True, False)
    
    objFile.WriteLine "[SMTP:Postmaster@technetium]   [SF:./POSTMASTER]
."
    objFile.WriteLine "[SMTP:*]" & vbTab & "0" & vbTab & "System"
    objFile.WriteLine vbTab & vbTab & "0" & vbTab & "System"
    
    Do Until rst.EOF
        strPOP3 = ""
        strPostOffice = Trim(rst("DomainName"))
        lngDomainID = rst("DomainID")
    
        Set rstAliases = New ADODB.Recordset
        rstAliases.Open "SELECT * FROM POP3Account WHERE DomainId=" &
lngDomainID & ";", cnDB
        While Not rstAliases.EOF
                If rstAliases("CatchAll") Then
                    strCatch = rstAliases("POP3UserName")
                End If
                strPOP3 = strPOP3 & ";" & Trim(rstAliases("POP3UserName"))
                rstAliases.MoveNext
        Wend
        rstAliases.Close
        Set rstAliases = Nothing
    
        Set rstAliases = New ADODB.Recordset
        rstAliases.Open "SELECT * FROM MailAlias WHERE DomainId=" &
lngDomainID & ";", cnDB
        While Not rstAliases.EOF
                strPOP3 = strPOP3 & ";" & Trim(rstAliases("AliasUserName"))
                rstAliases.MoveNext
        Wend
        rstAliases.Close
        Set rstAliases = Nothing
        strPOP3 = Right(strPOP3, Len(strPOP3) - 1)
        strPOPSplit = Split(strPOP3, ";")
        strSQL = "SELECT * FROM HostDomain " & _
                "WHERE DomainId=" & lngDomainID & " OR DomainAliasId=" &
lngDomainID & ";"
        Set rstDomains = New ADODB.Recordset
        rstDomains.Open strSQL, cnDB
        While Not rstDomains.EOF
            strDomain = Trim(rstDomains("DomainName"))
            objFile.WriteLine "[SMTP:*@" & strDomain & "]" & vbTab & _
                            "[SF:" & strPostOffice & "/" & strCatch & "]" &
vbTab & _
                            strPostOffice
            objFile.WriteLine "[SMTP:Postmaster@" & strDomain & "]" & vbTab
& _
                            "[SF:" & strPostOffice & "/Postmaster]" & vbTab
& _
                            strPostOffice
            For i = LBound(strPOPSplit) To UBound(strPOPSplit)
                objFile.WriteLine "[SMTP:" & strPOPSplit(i) & "@" &
strDomain & "]" & vbTab & _
                                "[SF:" & strPostOffice & "/" &
strPOPSplit(i) & "]" & vbTab & _
                                strPostOffice
            Next
            rstDomains.MoveNext
        Wend
        rstDomains.Close
        Set rstDomains = Nothing
        rst.MoveNext
    Loop
    
    objFile.Close
End Sub


Public Sub Auth()

    Dim cnDB As New ADODB.Connection
    Dim rst As New ADODB.Recordset
    Dim rstDomains As ADODB.Recordset
    Dim rstAliases As ADODB.Recordset
    
    Dim objFSO As New FileSystemObject
    Dim objFile As TextStream
    
    Dim strSQL As String
    Dim strPOP3 As String
    Dim strPostOffice As String
    Dim strCatch As String
    Dim strPOPSplit() As String
    Dim strDomain As String
    
    Dim lngDomainID As Long
    Dim i As Long
    
    cnDB.Open "Provider=sqloledb;" & _
                    "Data Source=" & SQLDBIP & ";" & _
                    "Initial Catalog=" & SQLDBDB & ";" & _
                    "User Id=" & SQLDBUser & ";" & _
                    "Password=" & SQLDBPass & ";"
    
    strSQL = "SELECT HostDomain.DomainName, POP3Account.POP3UserName,
POP3Account.POP3Password " & _
                "FROM POP3Account INNER JOIN HostDomain ON
POP3Account.DomainId = HostDomain.DomainId;"
        
    rst.Open strSQL, cnDB
    
    If Not objFSO.FolderExists(OUTPUTDIR & "config") Then
        objFSO.CreateFolder (OUTPUTDIR & "config")
    End If
    Set objFile = objFSO.CreateTextFile(OUTPUTDIR & "config\auth.tab", True,
False)
    
    objFile.WriteLine "Postmaster@.    1   password    .   ADMIN   "
    
    
    Do Until rst.EOF
        strPOP3 = rst("POP3UserName")
        strDomain = rst("DomainName")
        objFile.WriteLine strPOP3 & "@" & strDomain & vbTab & _
                        "1" & vbTab & _
                        rst("POP3Password") & vbTab & _
                        strDomain & vbTab & _
                        "USER" & vbTab
        rst.MoveNext
    Loop
    
    objFile.Close
End Sub


Public Sub PostOffice()

    Dim cnDB As New ADODB.Connection
    Dim rst As New ADODB.Recordset
    Dim rstDomains As ADODB.Recordset
    Dim rstAliases As ADODB.Recordset
    
    Dim objFSO As New FileSystemObject
    Dim objFile As TextStream
    
    Dim strSQL As String
    Dim strPOP3 As String
    Dim strPostOffice As String
    Dim strCatch As String
    Dim strPOPSplit() As String
    Dim strDomain As String
    
    Dim lngDomainID As Long
    Dim i As Long
    
    cnDB.Open "Provider=sqloledb;" & _
                    "Data Source=" & SQLDBIP & ";" & _
                    "Initial Catalog=" & SQLDBDB & ";" & _
                    "User Id=" & SQLDBUser & ";" & _
                    "Password=" & SQLDBPass & ";"
    
    strSQL = "SELECT * FROM HostDomain WHERE SubDomainId=0 AND
DomainAliasId=0;"
    
    rst.Open strSQL, cnDB
    
    If Not objFSO.FolderExists(OUTPUTDIR & "config") Then
        objFSO.CreateFolder (OUTPUTDIR & "config")
    End If
    Set objFile = objFSO.CreateTextFile(OUTPUTDIR & "config\postoffice.tab",
True, False)
    
    objFile.WriteLine "." & vbTab & "1" & vbTab & "."
    
    
    Do Until rst.EOF
        strDomain = rst("DomainName")
        objFile.WriteLine strDomain & vbTab & "1" & vbTab & strDomain &
vbTab
        rst.MoveNext
    Loop
    
    objFile.Close
End Sub

Public Sub PostOfficesDir()

    Dim cnDB As New ADODB.Connection
    Dim rst As New ADODB.Recordset
    Dim rstDomains As ADODB.Recordset
    Dim rstPOP3s As New ADODB.Recordset
    Dim rstAliases As New ADODB.Recordset
    
    Dim objFSO As New FileSystemObject
    Dim objFile As TextStream
    
    Dim strSQL As String
    Dim strPOP3 As String
    Dim strPostOffice As String
    Dim strCatch As String
    Dim strPOPSplit() As String
    Dim strDomain As String
    
    Dim lngDomainID As Long
    Dim i As Long
    
    cnDB.Open "Provider=sqloledb;" & _
                    "Data Source=" & SQLDBIP & ";" & _
                    "Initial Catalog=" & SQLDBDB & ";" & _
                    "User Id=" & SQLDBUser & ";" & _
                    "Password=" & SQLDBPass & ";"
    
    strSQL = "SELECT * FROM HostDomain WHERE SubDomainId=0 AND
DomainAliasId=0;"
    
    rst.Open strSQL, cnDB
    
    If Not objFSO.FolderExists(OUTPUTDIR & "config") Then
        objFSO.CreateFolder (OUTPUTDIR & "config")
    End If
    
    If Not objFSO.FolderExists(OUTPUTDIR & "config\postoffices") Then
        objFSO.CreateFolder (OUTPUTDIR & "config\postoffices")
    End If
    
    Do Until rst.EOF
        strDomain = rst("DomainName")
        If Not objFSO.FolderExists(OUTPUTDIR & "config\postoffices\" &
strDomain) Then
            objFSO.CreateFolder (OUTPUTDIR & "config\postoffices\" &
strDomain)
        End If
        Set objFile = objFSO.CreateTextFile(OUTPUTDIR &
"config\postoffices\" & strDomain & "\mailbox.tab", True, False)
        With objFile
            .Write "Postmaster" & vbTab & "1" & vbTab & "-1" & vbTab & "0" &
vbTab
            rstPOP3s.Open "SELECT * FROM POP3Account WHERE DomainId=" &
rst("DomainID") & ";", cnDB
            While Not rstPOP3s.EOF
                .Write vbNewLine & rstPOP3s("POP3UserName") & vbTab & "1" &
vbTab & "-1" & vbTab & "0" & vbTab & "!$%NULL%$!"
                rstPOP3s.MoveNext
            Wend
            rstPOP3s.Close
            rstAliases.Open "SELECT * FROM MailAlias WHERE DomainId=" &
rst("DomainID") & ";", cnDB
            While Not rstAliases.EOF
                .Write vbNewLine & rstAliases("AliasUserName") & vbTab & "1"
& vbTab & "-1" & vbTab & "1" & vbTab & "[SMTP:" & rstAliases("ForwardsTo") &
"]"
                rstAliases.MoveNext
            Wend
            rstAliases.Close
            '.WriteLine ""
            .Close
        End With
        Set objFile = Nothing
        
        rst.MoveNext
    Loop
    
End Sub
